]> git.proxmox.com Git - debcargo-conf.git/blob - vars.sh.frag
vars.sh.frag: allow PKGBASE to be overridden, this helps debcargo#22 work better...
[debcargo-conf.git] / vars.sh.frag
1 # -*- mode: sh -*-
2 # Common shell utilities.
3 #
4 # Envvars:
5 # DEBCARGO
6 # Path to debcargo. Set this to use your custom version, e.g. from git.
7 set -e
8
9 abort() { local x=$1; shift; for i in "$@"; do echo >&2 "$0: abort: $i"; done; exit "$x"; }
10
11 mkdir -p "$(dirname "$0")/.git/hooks"
12 HOOK_COMMIT="$(dirname "$0")/.git/hooks/pre-commit"
13 if [ ! -x "$HOOK_COMMIT" ]; then
14 cat <<'eof' >"$HOOK_COMMIT"
15 #!/bin/sh
16 if git rev-parse -q --verify MERGE_HEAD; then exit; fi
17 case $(git rev-parse --abbrev-ref HEAD) in
18 pending-*) true;;
19 *) if git diff --cached --name-only | \
20 grep '^src/.*/debian/changelog$' | \
21 while read x; do if ! [ -f "$x" ]; then continue; fi; echo "$x: $(head -n1 $x)"; done | \
22 grep -v UNRELEASED-FIXME-AUTOGENERATED-DEBCARGO; then
23 echo >&2 "please don't finalise changelogs directly on the master branch, use ./release.sh instead"; exit 1;
24 fi;;
25 esac
26 eof
27 chmod +x "$HOOK_COMMIT"
28 fi
29
30 if [ -n "$DEBCARGO" ]; then
31 true
32 elif which debcargo >/dev/null; then
33 DEBCARGO=$(which debcargo)
34 elif [ -f "$HOME/.cargo/bin/debcargo" ]; then
35 DEBCARGO="$HOME/.cargo/bin/debcargo"
36 else
37 abort 1 "debcargo not found, run \`cargo install debcargo\` or set DEBCARGO to point to it"
38 fi
39
40 test -x "$DEBCARGO" || abort 1 "debcargo found but not executable: $DEBCARGO"
41 dcver=$($DEBCARGO --version | sed -ne 's/debcargo //p')
42 case $dcver in
43 2.0.*|2.1.*|2.2.*|2.3.*) abort 1 "unsupported debcargo version $dcver. try reinstalling with \`cargo install debcargo --force\`";;
44 2.4.*) true;;
45 *) abort 1 "unsupported debcargo version: $dcver";;
46 esac
47
48 if [ $# -ne 1 -a $# -ne 2 ]; then
49 echo >&2 "Usage: $0 <rust-crate-name>"
50 echo >&2 " $0 <rust-crate-name> <old-version>"
51 echo >&2 "See README.rst for more details on usage."
52 exit 2
53 fi
54
55 CRATE="$1"
56 VER="$2"
57
58 PKGNAME=${PKGNAME:-$($DEBCARGO deb-src-name "$CRATE" $VER || abort 1 "couldn't find crate $CRATE")}
59 PKGBASE=${PKGBASE:-$($DEBCARGO deb-src-name "$CRATE" || abort 1 "couldn't find crate $CRATE")}
60 PKGDIR_REL="src/$PKGNAME"
61 PKGDIR="$PWD/$PKGDIR_REL"
62 BUILDDIR="$PWD/build/$PKGNAME"
63 PKGCFG="$PKGDIR/debian/debcargo.toml"
64
65 mkdir -p "$(dirname $BUILDDIR)"
66 ln -srf "$PWD/build.sh" "$PWD/build/build.sh"
67 chmod +x "$PWD/build/build.sh"
68
69 if [ -z "$CRATE" ]; then
70 abort 2 "Usage: $0 <crate> [<version>]"
71 fi
72
73 run_debcargo() {
74 rm -rf "$BUILDDIR" "$(dirname "$BUILDDIR")/rust-${PKGNAME}_${REALVER:-$VER}"*.orig.tar.*
75 $DEBCARGO package --config "$PKGCFG" --directory "$BUILDDIR" "$@" "$CRATE" "${REALVER:-$VER}"
76 }
77
78 shouldbuild() {
79 local dst="$1"
80 local src="$2"
81 test ! -e "$dst" -o "$src" -nt "$dst"
82 }
83
84 get_existing_version() {
85 sed -nre "s/.*Package .* (.*) from crates.io.*/\1/gp" "$1/debian/changelog" | head -n1
86 }